import json

from dataclasses import asdict, is_dataclass
from typing import Any, Union, Dict


class DataclassEncoder(json.JSONEncoder):
    def default(self, o: Any) -> Union[Any, Dict[str, Any]]:
        if is_dataclass(o):
            return asdict(o)
        return o
