from .paper import Paper
from .profile import Profile
from ..utils import fetch
from dataclasses import dataclass, field
from typing import List


@dataclass
class ScholarProfile(Profile):
    homepage: str = field(default=None, repr=False, compare=False)
    _papers: List[Paper] = field(default_factory=list,
                                 repr=False,
                                 compare=False)

    @property
    def papers(self) -> List[Paper]:
        if self._papers is None:
            raise AttributeError(
                'Publication data has not been collected. Set papers=True when calling GoogleScholar.search_id() or call on ScholarProfile.collect_papers().'
            )
        return self._papers

    @papers.setter
    def papers(self, value):
        self._papers = value

    @classmethod
    def from_thumbnail(cls, thmbnl_profile) -> 'ScholarProfile':
        pass

