from ..model import Paper
from ..utils import select, lower_txt

AUTHORS = slice(0, -1, 2)
JOURNALS = slice(1, None, 2)

def paper_loader(soup, meta=None):
    table = soup.select_one('#gsc_a_b')

    titles = select(table, '.gsc_a_t a')

    author_journal = select(table, '.gsc_a_t div')
    authors = author_journal[AUTHORS]
    journals = author_journal[JOURNALS]

    pub_years = select(table, '.gsc_a_y')
    num_citations = select(table, '.gsc_a_c')

    details = zip(titles, authors, journals, pub_years, num_citations)

    return [Paper(*detail) for detail in details]
