import os
import requests

from random import choice
from time import sleep
from bs4 import BeautifulSoup
from typing import List, Dict


PATH = os.path.join(os.path.dirname(__file__), "user_agents.txt")

HEADER = {
    "authority": "scholar.google.ca",
    "method": "GET",
    "scheme": "https",
    "accept": "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3",
    "accept-encoding": "gzip, deflate, br",
    "accept-language": "en-CA,en;q=0.9,es-PE;q=0.8,es;q=0.7,en-GB;q=0.6,en-US;q=0.5",
    "cache-control": "max-age=0",
    "referer": "https://scholar.google.ca/scholar",
    "upgrade-insecure-requests": "1",
}

def fetch(url: str, seconds: int, **kwargs: Dict[str, str]) -> BeautifulSoup:
    '''
    Sends a GET requests to a given URL, converting the response to a BeautifulSoup object.

    Arguments:
        url: URL to send GET request
        seconds: Number of seocnds of delay per request
        **kwargs: Other arguments to send on with request
    '''
    with requests.Session() as session:
        with session.get(url, headers=rand_header(), **kwargs) as response:
            response.raise_for_status()
            sleep(seconds)
            return BeautifulSoup(response.content, 'html.parser')


def rand_header():
    with open(PATH, 'r') as f:
        HEADER['User-Agent'] = choice(f.read().splitlines())
    return HEADER
